import React from 'react';

interface SlideSectionProps {
    id: string;
    heading?: string | undefined;
    type: string;
    file?: string | undefined;
    value: string;
    highlight?: string | undefined;
    content: string;
    previewImage?: string | undefined;
    sectionType: "slide";
}
interface MarkdownSectionProps {
    id: string;
    content: string;
    heading: string;
    sectionType: "md";
}
interface HeaderSectionProps {
    id: string;
    headline: string;
    subheadline: string;
    sectionType: "header";
    content: string;
    links: Array<{
        url: string;
        type: string;
    }>;
    image: string;
}
type Section = SlideSectionProps | MarkdownSectionProps | HeaderSectionProps;
type CourseProps = {
    id: number;
    lessons: Section[];
    canExit: boolean;
    menuHoverColor?: string;
    menuSelectedColor?: string;
};
declare const Course: React.FC<CourseProps>;

export { Course };
