"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Course: () => Course
});
module.exports = __toCommonJS(src_exports);

// src/components/Course.tsx
var import_react4 = __toESM(require("react"));

// src/components/HeaderSection.tsx
var import_react = __toESM(require("react"));
var import_react_markdown = __toESM(require("react-markdown"));
var import_rehype_raw = __toESM(require("rehype-raw"));
var HeaderSection = (props) => {
  return /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement("div", { className: "flex flex-col items-center w-full text-center container" }, /* @__PURE__ */ import_react.default.createElement("div", { className: "text-6xl font-bold pt-16" }, props.headline), /* @__PURE__ */ import_react.default.createElement("p", { className: "mt-4 text-2xl" }, props.subheadline), /* @__PURE__ */ import_react.default.createElement(
    "img",
    {
      className: "pt-16 w-full",
      src: `https://hungrimind.com/${props.image}`
    }
  ), /* @__PURE__ */ import_react.default.createElement("div", { className: "md:w-1/2 text-start" }, /* @__PURE__ */ import_react.default.createElement(import_react_markdown.default, { rehypePlugins: [import_rehype_raw.default] }, props.content)), /* @__PURE__ */ import_react.default.createElement("div", { className: "flex justify-center p-2 space-x-4" }, props.links.map((link, index) => /* @__PURE__ */ import_react.default.createElement(
    "a",
    {
      key: index,
      href: link.url,
      target: "_blank",
      className: "py-2.5 px-5 mt-2 font-medium text-center text-white bg-black dark:text-black dark:bg-white rounded"
    },
    (() => {
      switch (link.type) {
        case "github":
          return /* @__PURE__ */ import_react.default.createElement("div", null, "Course Code");
        case "discord":
          return /* @__PURE__ */ import_react.default.createElement("div", null, "Join Community");
        default:
          return /* @__PURE__ */ import_react.default.createElement("div", null, "Error");
      }
    })()
  ))), /* @__PURE__ */ import_react.default.createElement("p", { id: "setup", className: "mt-16 pb-8 text-2xl" }, "\u2B05 Click the check button to get started")));
};
var HeaderSection_default = HeaderSection;

// src/components/SlideSection.tsx
var import_prismjs = __toESM(require("prismjs"));
var import_prism_dart = require("prismjs/components/prism-dart");
var import_prism_markdown = require("prismjs/components/prism-markdown");
var import_prism_yaml = require("prismjs/components/prism-yaml");
var import_prism_line_highlight = require("prismjs/plugins/line-highlight/prism-line-highlight");
var import_prism_line_highlight2 = require("prismjs/plugins/line-highlight/prism-line-highlight.css");
var import_react2 = __toESM(require("react"));
var import_react_markdown2 = __toESM(require("react-markdown"));
var import_rehype_raw2 = __toESM(require("rehype-raw"));
var SlideSection = (props) => {
  (0, import_react2.useEffect)(() => {
    import_prismjs.default.highlightAll();
  });
  return /* @__PURE__ */ import_react2.default.createElement("div", { className: "relative flex h-full w-full" }, /* @__PURE__ */ import_react2.default.createElement(
    "div",
    {
      className: `${props.previewOpen ? "backdrop-blur" : "opacity-0 hidden"} transition-opacity absolute w-full h-full z-10`
    }
  ), /* @__PURE__ */ import_react2.default.createElement("section", { className: "hidden sm:flex w-full" }, /* @__PURE__ */ import_react2.default.createElement(
    DesktopView,
    {
      content: props.content,
      previewOpen: props.previewOpen,
      setPreviewOpen: props.setPreviewOpen
    }
  )), /* @__PURE__ */ import_react2.default.createElement("section", { className: "sm:hidden w-full" }, /* @__PURE__ */ import_react2.default.createElement(
    MobileView,
    {
      content: props.content,
      previewOpen: props.previewOpen,
      setPreviewOpen: props.setPreviewOpen
    }
  )));
};
var DesktopView = ({ content, previewOpen }) => {
  return /* @__PURE__ */ import_react2.default.createElement("div", { className: "flex overflow-y-auto h-full w-full items-center relative" }, /* @__PURE__ */ import_react2.default.createElement("div", { className: "content-section w-1/2 my-auto py-16" }, /* @__PURE__ */ import_react2.default.createElement("h2", { className: "px-4 text-4xl font-bold" }, content.heading), /* @__PURE__ */ import_react2.default.createElement("p", { className: "px-4" }, /* @__PURE__ */ import_react2.default.createElement(import_react_markdown2.default, { rehypePlugins: [import_rehype_raw2.default] }, content.content))), /* @__PURE__ */ import_react2.default.createElement(CodeImageThing, { content }), /* @__PURE__ */ import_react2.default.createElement(
    "div",
    {
      className: `${previewOpen ? "scale-100" : "scale-0"} transition-transform absolute left-0 right-0 bottom-0 top-0 z-100 flex justify-center items-center z-20`
    },
    /* @__PURE__ */ import_react2.default.createElement(
      "img",
      {
        className: "shadow-2xl mb-2 rounded-xl h-4/5",
        src: `../../../${content?.previewImage}`,
        alt: "Preview"
      }
    )
  ));
};
var MobileView = ({ content }) => {
  return /* @__PURE__ */ import_react2.default.createElement(import_react2.default.Fragment, null, /* @__PURE__ */ import_react2.default.createElement("div", { className: "content-section overflow-hidden" }, /* @__PURE__ */ import_react2.default.createElement("div", null, /* @__PURE__ */ import_react2.default.createElement(
    "h2",
    {
      className: `px-4 text-4xl font-bold sm:transition-opacity duration-500`
    },
    content?.heading
  ), /* @__PURE__ */ import_react2.default.createElement("p", { className: `px-4 sm:transition-opacity duration-500 ` }, /* @__PURE__ */ import_react2.default.createElement(import_react_markdown2.default, { rehypePlugins: [import_rehype_raw2.default] }, content?.content)), /* @__PURE__ */ import_react2.default.createElement("div", { className: "h-96" }))), /* @__PURE__ */ import_react2.default.createElement(CodeImageThing, { content }));
};
function CodeImageThing({ content }) {
  function highlightTranslator(type) {
    if (type === "flutter") {
      return "language-dart";
    }
    return `language-${type}`;
  }
  return /* @__PURE__ */ import_react2.default.createElement("div", { className: "sticky top-0 h-full sm:block sm:w-1/2" }, /* @__PURE__ */ import_react2.default.createElement("div", { className: "overflow-visible h-full bg-neutral-50 dark:bg-neutral-900 relative rounded-xl" }, (() => {
    switch (content?.type) {
      case "image":
        return /* @__PURE__ */ import_react2.default.createElement("div", { className: "flex justify-center items-center p-4 mb-20 h-full" }, /* @__PURE__ */ import_react2.default.createElement(
          "img",
          {
            className: "object-contain max-h-full rounded-xl",
            src: `/${content.value}`,
            alt: "Comment"
          }
        ));
      case "text":
        return /* @__PURE__ */ import_react2.default.createElement("div", { className: "flex justify-start items-center p-4 h-full text-white" }, content.value);
      case "md":
      case "yaml":
      case "flutter":
        return /* @__PURE__ */ import_react2.default.createElement("div", { className: "overflow-y-auto h-full text-white flex flex-col" }, content?.file !== void 0 && /* @__PURE__ */ import_react2.default.createElement("div", { className: " dark:bg-neutral-900 text-black dark:text-white px-4 py-1" }, content.file), /* @__PURE__ */ import_react2.default.createElement(
          "pre",
          {
            className: "line-numbers flex-1",
            "data-line": content.highlight ?? ""
          },
          /* @__PURE__ */ import_react2.default.createElement(
            "code",
            {
              className: `pl-0 ${highlightTranslator(content.type)}`
            },
            content.value
          )
        ));
      default:
        return null;
    }
  })()));
}
var SlideSection_default = SlideSection;

// src/components/ui/button.tsx
var import_react_slot = require("@radix-ui/react-slot");
var import_class_variance_authority = require("class-variance-authority");
var React3 = __toESM(require("react"));

// src/lib/utils.ts
var import_clsx = require("clsx");
var import_tailwind_merge = require("tailwind-merge");
function cn(...inputs) {
  return (0, import_tailwind_merge.twMerge)((0, import_clsx.clsx)(inputs));
}

// src/components/ui/button.tsx
var buttonVariants = (0, import_class_variance_authority.cva)(
  "inline-flex items-center justify-center whitespace-nowrap rounded-md text-sm font-medium ring-offset-white transition-colors focus-visible:outline-none focus-visible:ring-2 focus-visible:ring-neutral-950 focus-visible:ring-offset-2 disabled:pointer-events-none disabled:opacity-50 dark:ring-offset-neutral-950 dark:focus-visible:ring-neutral-300",
  {
    variants: {
      variant: {
        default: "bg-neutral-900 text-neutral-50 hover:bg-neutral-900/90 dark:bg-neutral-50 dark:text-neutral-900 dark:hover:bg-neutral-50/90",
        destructive: "bg-red-500 text-neutral-50 hover:bg-red-500/90 dark:bg-red-900 dark:text-neutral-50 dark:hover:bg-red-900/90",
        outline: "border border-neutral-200 bg-white hover:bg-neutral-100 hover:text-neutral-900 dark:border-neutral-800 dark:bg-neutral-950 dark:hover:bg-neutral-800 dark:hover:text-neutral-50",
        secondary: "bg-neutral-100 text-neutral-900 hover:bg-neutral-100/80 dark:bg-neutral-800 dark:text-neutral-50 dark:hover:bg-neutral-800/80",
        ghost: "hover:bg-neutral-100 hover:text-neutral-900 dark:hover:bg-neutral-800 dark:hover:text-neutral-50",
        link: "text-neutral-900 underline-offset-4 hover:underline dark:text-neutral-50"
      },
      size: {
        default: "h-10 px-4 py-2",
        sm: "h-9 rounded-md px-3",
        lg: "h-11 rounded-md px-8",
        icon: "h-10 w-10"
      }
    },
    defaultVariants: {
      variant: "default",
      size: "default"
    }
  }
);
var Button = React3.forwardRef(
  ({ className, variant, size, asChild = false, ...props }, ref) => {
    const Comp = asChild ? import_react_slot.Slot : "button";
    return /* @__PURE__ */ React3.createElement(
      Comp,
      {
        className: cn(buttonVariants({ variant, size, className })),
        ref,
        ...props
      }
    );
  }
);
Button.displayName = "Button";

// src/components/Course.tsx
var import_lucide_react = require("lucide-react");

// src/components/MarkdownSection.tsx
var import_react3 = __toESM(require("react"));
var import_react_markdown3 = __toESM(require("react-markdown"));
var import_rehype_raw3 = __toESM(require("rehype-raw"));
var MarkdownSection = (props) => {
  return /* @__PURE__ */ import_react3.default.createElement("div", { className: "h-full w-full flex flex-col justify-center items-center text-center" }, /* @__PURE__ */ import_react3.default.createElement(import_react_markdown3.default, { className: "md:w-1/2", rehypePlugins: [import_rehype_raw3.default] }, props.content));
};
var MarkdownSection_default = MarkdownSection;

// src/components/Course.tsx
var Course = ({
  id,
  lessons,
  canExit,
  menuHoverColor,
  menuSelectedColor
}) => {
  const [previewOpen, setPreviewOpen] = import_react4.default.useState(false);
  const [menuOpen, setMenuOpen] = import_react4.default.useState(false);
  const listItemRef = (0, import_react4.useRef)(null);
  const divRef = import_react4.default.useRef(null);
  const [cookieArray, setCookieArray] = import_react4.default.useState(
    void 0
  );
  import_react4.default.useEffect(() => {
    const cookie = document.cookie.split(";").find((cookie2) => cookie2.includes(`current-position-for-${id}`));
    if (cookie) {
      const currentLessonId = cookie.split("=")[1];
      console.log(lessons.findIndex((l) => l.id == currentLessonId));
      setIndex(lessons.findIndex((l) => l.id == currentLessonId));
    }
    let cookieArray2 = document.cookie.split("; ").find((row) => row.startsWith(`progress-for-${id}`))?.split("=")[1].split(",");
    setCookieArray(cookieArray2);
  }, [lessons]);
  const [currentIndex, setIndex] = import_react4.default.useState(0);
  import_react4.default.useEffect(() => {
    if (menuOpen) {
      listItemRef.current.scrollIntoView({
        behavior: "smooth",
        block: "center"
      });
    }
  }, [menuOpen, listItemRef, currentIndex]);
  return /* @__PURE__ */ import_react4.default.createElement("div", { className: "flex h-full w-full relative" }, /* @__PURE__ */ import_react4.default.createElement(
    "div",
    {
      className: `w-[350px] border-r dark:border-r-neutral-700 overflow-y-auto transition-opacity ${menuOpen ? "opacity-100 block" : "opacity-0 hidden"}`
    },
    /* @__PURE__ */ import_react4.default.createElement("div", { className: "side-menu-content" }, /* @__PURE__ */ import_react4.default.createElement("div", { className: "py-4 pr-4 pl-2 sticky top-0 border-b dark:border-b-neutral-700 backdrop-blur" }, /* @__PURE__ */ import_react4.default.createElement("div", { className: "flex justify-between" }, /* @__PURE__ */ import_react4.default.createElement(
      "button",
      {
        onClick: () => setMenuOpen(false),
        className: buttonVariants({ variant: "ghost" })
      },
      /* @__PURE__ */ import_react4.default.createElement(import_lucide_react.PanelLeftClose, { size: 24 })
    ), canExit && /* @__PURE__ */ import_react4.default.createElement(
      "a",
      {
        href: "/courses",
        className: buttonVariants({ variant: "ghost" })
      },
      /* @__PURE__ */ import_react4.default.createElement("div", { className: "text-red-400" }, "Exit Course")
    ))), /* @__PURE__ */ import_react4.default.createElement("ul", { className: "py-4 px-4" }, lessons.map((section, index) => /* @__PURE__ */ import_react4.default.createElement("li", { key: index }, /* @__PURE__ */ import_react4.default.createElement(
      "button",
      {
        onClick: () => {
          setIndex(index);
          document.cookie = `current-position-for-${id}=${section.id}`;
        },
        ref: index === currentIndex ? listItemRef : void 0,
        className: `block w-full p-2 text-left ${menuHoverColor != null ? menuHoverColor : "hover:bg-neutral-100 dark:hover:bg-neutral-800"}  ${index === currentIndex ? `${menuSelectedColor != null ? menuSelectedColor : "bg-neutral-200 dark:bg-neutral-700"} rounded` : ""} ${cookieArray?.includes(section.id.toString()) ? "dark:text-green-300 text-green-600" : ""}`
      },
      (() => {
        switch (section.sectionType) {
          case "header":
            return /* @__PURE__ */ import_react4.default.createElement("span", null, "Introduction");
          default:
            return /* @__PURE__ */ import_react4.default.createElement("span", null, section.heading);
        }
      })()
    )))))
  ), /* @__PURE__ */ import_react4.default.createElement(
    "div",
    {
      className: "relative transition-opacity w-full overflow-y-auto",
      ref: divRef
    },
    /* @__PURE__ */ import_react4.default.createElement(
      BottomNavigation,
      {
        courseId: id,
        currentIndex,
        previewOpen,
        setIndex,
        contentLength: lessons.length,
        setPreviewOpen,
        content: lessons,
        menuOpen,
        setMenuOpen,
        cookieArray,
        setCookieArray
      }
    ),
    (() => {
      switch (lessons[currentIndex].sectionType) {
        case "slide":
          return /* @__PURE__ */ import_react4.default.createElement(
            SlideSection_default,
            {
              content: lessons[currentIndex],
              previewOpen,
              setPreviewOpen
            }
          );
        case "md":
          return /* @__PURE__ */ import_react4.default.createElement(
            MarkdownSection_default,
            {
              ...lessons[currentIndex]
            }
          );
        case "header":
          return /* @__PURE__ */ import_react4.default.createElement(
            HeaderSection_default,
            {
              ...lessons[currentIndex]
            }
          );
        default:
          return null;
      }
    })()
  ));
};
function BottomNavigation({
  courseId,
  currentIndex,
  previewOpen,
  contentLength,
  setIndex,
  setPreviewOpen,
  content,
  menuOpen,
  setMenuOpen,
  cookieArray,
  setCookieArray
}) {
  const completeRef = import_react4.default.useRef(null);
  const hasPreview = content[currentIndex] !== void 0 && "previewImage" in content[currentIndex];
  import_react4.default.useEffect(() => {
    document.addEventListener("keydown", function(event) {
      const keyPressed = event.key.toLowerCase();
      if (keyPressed === "c" && !event.ctrlKey && !event.altKey && !event.shiftKey && !event.metaKey) {
        completeKeymap();
      }
    });
  }, []);
  function completeKeymap() {
    const item = completeRef.current;
    if (!item)
      return;
    item.classList.add("scale-75");
    setTimeout(() => {
      item.classList.remove("scale-75");
    }, 100);
    completeRef.current?.click();
    completeRef.current?.focus();
  }
  function onClickComplete() {
    if (!cookieArray) {
      cookieArray = [];
    }
    if (!cookieArray.includes(content[currentIndex].id.toString())) {
      cookieArray.push(content[currentIndex].id.toString());
      setCookieArray(cookieArray);
    }
    document.cookie = `progress-for-${courseId}=${cookieArray}`;
    if (currentIndex === contentLength - 1) {
      return;
    }
    if (content[currentIndex + 1].sectionType !== "slide" || content[currentIndex + 1].previewImage === void 0) {
      setPreviewOpen(false);
    }
    setIndex(currentIndex + 1);
    console.log(content[currentIndex]);
    document.cookie = `current-position-for-${courseId}=${content[currentIndex + 1].id}`;
  }
  return /* @__PURE__ */ import_react4.default.createElement(
    "div",
    {
      className: `fixed z-50 bottom-2 left-2 p-4 ${menuOpen ? `pl-72` : ``}`
    },
    /* @__PURE__ */ import_react4.default.createElement(
      "div",
      {
        className: `flex h-full items-center justify-center space-x-4 rounded`
      },
      !menuOpen && /* @__PURE__ */ import_react4.default.createElement(
        "button",
        {
          "data-tooltip-target": "tooltip-menu",
          type: "button",
          className: buttonVariants({ variant: "default" }),
          onClick: () => setMenuOpen(!menuOpen)
        },
        /* @__PURE__ */ import_react4.default.createElement("div", { className: "w-full h-full flex items-center justify-center active:scale-75 transition-transform" }, /* @__PURE__ */ import_react4.default.createElement(import_lucide_react.PanelLeftOpen, { size: 28 })),
        /* @__PURE__ */ import_react4.default.createElement("span", { className: "sr-only" }, "Menu")
      ),
      /* @__PURE__ */ import_react4.default.createElement(
        "button",
        {
          "data-tooltip-target": "tooltip-complete",
          type: "button",
          className: buttonVariants({ variant: "default" }),
          onClick: onClickComplete
        },
        /* @__PURE__ */ import_react4.default.createElement(
          "div",
          {
            ref: completeRef,
            className: "w-full h-full flex items-center justify-center active:scale-75 transition-transform"
          },
          /* @__PURE__ */ import_react4.default.createElement(import_lucide_react.CheckIcon, { size: 28 })
        ),
        /* @__PURE__ */ import_react4.default.createElement("span", { className: "sr-only" }, "Complete")
      ),
      /* @__PURE__ */ import_react4.default.createElement(
        "div",
        {
          id: "tooltip-complete",
          role: "tooltip",
          className: "absolute z-10 invisible inline-block px-3 py-2 text-sm font-medium text-white transition-opacity duration-300 bg-neutral-900 rounded-lg shadow-sm opacity-0 tooltip dark:bg-neutral-700"
        },
        "Complete",
        /* @__PURE__ */ import_react4.default.createElement("div", { className: "tooltip-arrow", "data-popper-arrow": true })
      ),
      hasPreview && /* @__PURE__ */ import_react4.default.createElement(import_react4.default.Fragment, null, /* @__PURE__ */ import_react4.default.createElement(
        "button",
        {
          onClick: () => setPreviewOpen(!previewOpen),
          "data-tooltip-target": "tooltip-preview",
          type: "button",
          className: buttonVariants({ variant: "default" })
        },
        /* @__PURE__ */ import_react4.default.createElement("div", { className: "w-full h-full flex items-center justify-center active:scale-75 transition-transform" }, /* @__PURE__ */ import_react4.default.createElement(import_lucide_react.Smartphone, { size: 28 })),
        /* @__PURE__ */ import_react4.default.createElement("span", { className: "sr-only" }, "Preview")
      ), /* @__PURE__ */ import_react4.default.createElement(
        "div",
        {
          id: "tooltip-preview",
          role: "tooltip",
          className: "absolute z-10 invisible inline-block px-3 py-2 text-sm font-medium text-white transition-opacity duration-300 bg-neutral-900 rounded-lg shadow-sm opacity-0 tooltip dark:bg-neutral-700"
        },
        "Preview",
        /* @__PURE__ */ import_react4.default.createElement("div", { className: "tooltip-arrow", "data-popper-arrow": true })
      ))
    )
  );
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Course
});
