// src/components/Course.tsx
import React5, { useRef } from "react";

// src/components/HeaderSection.tsx
import React from "react";
import Markdown from "react-markdown";
import rehypeRaw from "rehype-raw";
var HeaderSection = (props) => {
  return /* @__PURE__ */ React.createElement("div", null, /* @__PURE__ */ React.createElement("div", { className: "flex flex-col items-center w-full text-center container" }, /* @__PURE__ */ React.createElement("div", { className: "text-6xl font-bold pt-16" }, props.headline), /* @__PURE__ */ React.createElement("p", { className: "mt-4 text-2xl" }, props.subheadline), /* @__PURE__ */ React.createElement(
    "img",
    {
      className: "pt-16 w-full",
      src: `https://hungrimind.com/${props.image}`
    }
  ), /* @__PURE__ */ React.createElement("div", { className: "md:w-1/2 text-start" }, /* @__PURE__ */ React.createElement(Markdown, { rehypePlugins: [rehypeRaw] }, props.content)), /* @__PURE__ */ React.createElement("div", { className: "flex justify-center p-2 space-x-4" }, props.links.map((link, index) => /* @__PURE__ */ React.createElement(
    "a",
    {
      key: index,
      href: link.url,
      target: "_blank",
      className: "py-2.5 px-5 mt-2 font-medium text-center text-white bg-black dark:text-black dark:bg-white rounded"
    },
    (() => {
      switch (link.type) {
        case "github":
          return /* @__PURE__ */ React.createElement("div", null, "Course Code");
        case "discord":
          return /* @__PURE__ */ React.createElement("div", null, "Join Community");
        default:
          return /* @__PURE__ */ React.createElement("div", null, "Error");
      }
    })()
  ))), /* @__PURE__ */ React.createElement("p", { id: "setup", className: "mt-16 pb-8 text-2xl" }, "\u2B05 Click the check button to get started")));
};
var HeaderSection_default = HeaderSection;

// src/components/SlideSection.tsx
import Prism from "prismjs";
import "prismjs/components/prism-dart";
import "prismjs/components/prism-markdown";
import "prismjs/components/prism-yaml";
import "prismjs/plugins/line-highlight/prism-line-highlight";
import "prismjs/plugins/line-highlight/prism-line-highlight.css";
import React2, { useEffect } from "react";
import Markdown2 from "react-markdown";
import rehypeRaw2 from "rehype-raw";
var SlideSection = (props) => {
  useEffect(() => {
    Prism.highlightAll();
  });
  return /* @__PURE__ */ React2.createElement("div", { className: "relative flex h-full w-full" }, /* @__PURE__ */ React2.createElement(
    "div",
    {
      className: `${props.previewOpen ? "backdrop-blur" : "opacity-0 hidden"} transition-opacity absolute w-full h-full z-10`
    }
  ), /* @__PURE__ */ React2.createElement("section", { className: "hidden sm:flex w-full" }, /* @__PURE__ */ React2.createElement(
    DesktopView,
    {
      content: props.content,
      previewOpen: props.previewOpen,
      setPreviewOpen: props.setPreviewOpen
    }
  )), /* @__PURE__ */ React2.createElement("section", { className: "sm:hidden w-full" }, /* @__PURE__ */ React2.createElement(
    MobileView,
    {
      content: props.content,
      previewOpen: props.previewOpen,
      setPreviewOpen: props.setPreviewOpen
    }
  )));
};
var DesktopView = ({ content, previewOpen }) => {
  return /* @__PURE__ */ React2.createElement("div", { className: "flex overflow-y-auto h-full w-full items-center relative" }, /* @__PURE__ */ React2.createElement("div", { className: "content-section w-1/2 my-auto py-16" }, /* @__PURE__ */ React2.createElement("h2", { className: "px-4 text-4xl font-bold" }, content.heading), /* @__PURE__ */ React2.createElement("p", { className: "px-4" }, /* @__PURE__ */ React2.createElement(Markdown2, { rehypePlugins: [rehypeRaw2] }, content.content))), /* @__PURE__ */ React2.createElement(CodeImageThing, { content }), /* @__PURE__ */ React2.createElement(
    "div",
    {
      className: `${previewOpen ? "scale-100" : "scale-0"} transition-transform absolute left-0 right-0 bottom-0 top-0 z-100 flex justify-center items-center z-20`
    },
    /* @__PURE__ */ React2.createElement(
      "img",
      {
        className: "shadow-2xl mb-2 rounded-xl h-4/5",
        src: `../../../${content?.previewImage}`,
        alt: "Preview"
      }
    )
  ));
};
var MobileView = ({ content }) => {
  return /* @__PURE__ */ React2.createElement(React2.Fragment, null, /* @__PURE__ */ React2.createElement("div", { className: "content-section overflow-hidden" }, /* @__PURE__ */ React2.createElement("div", null, /* @__PURE__ */ React2.createElement(
    "h2",
    {
      className: `px-4 text-4xl font-bold sm:transition-opacity duration-500`
    },
    content?.heading
  ), /* @__PURE__ */ React2.createElement("p", { className: `px-4 sm:transition-opacity duration-500 ` }, /* @__PURE__ */ React2.createElement(Markdown2, { rehypePlugins: [rehypeRaw2] }, content?.content)), /* @__PURE__ */ React2.createElement("div", { className: "h-96" }))), /* @__PURE__ */ React2.createElement(CodeImageThing, { content }));
};
function CodeImageThing({ content }) {
  function highlightTranslator(type) {
    if (type === "flutter") {
      return "language-dart";
    }
    return `language-${type}`;
  }
  return /* @__PURE__ */ React2.createElement("div", { className: "sticky top-0 h-full sm:block sm:w-1/2" }, /* @__PURE__ */ React2.createElement("div", { className: "overflow-visible h-full bg-neutral-50 dark:bg-neutral-900 relative rounded-xl" }, (() => {
    switch (content?.type) {
      case "image":
        return /* @__PURE__ */ React2.createElement("div", { className: "flex justify-center items-center p-4 mb-20 h-full" }, /* @__PURE__ */ React2.createElement(
          "img",
          {
            className: "object-contain max-h-full rounded-xl",
            src: `/${content.value}`,
            alt: "Comment"
          }
        ));
      case "text":
        return /* @__PURE__ */ React2.createElement("div", { className: "flex justify-start items-center p-4 h-full text-white" }, content.value);
      case "md":
      case "yaml":
      case "flutter":
        return /* @__PURE__ */ React2.createElement("div", { className: "overflow-y-auto h-full text-white flex flex-col" }, content?.file !== void 0 && /* @__PURE__ */ React2.createElement("div", { className: " dark:bg-neutral-900 text-black dark:text-white px-4 py-1" }, content.file), /* @__PURE__ */ React2.createElement(
          "pre",
          {
            className: "line-numbers flex-1",
            "data-line": content.highlight ?? ""
          },
          /* @__PURE__ */ React2.createElement(
            "code",
            {
              className: `pl-0 ${highlightTranslator(content.type)}`
            },
            content.value
          )
        ));
      default:
        return null;
    }
  })()));
}
var SlideSection_default = SlideSection;

// src/components/ui/button.tsx
import { Slot } from "@radix-ui/react-slot";
import { cva } from "class-variance-authority";
import * as React3 from "react";

// src/lib/utils.ts
import { clsx } from "clsx";
import { twMerge } from "tailwind-merge";
function cn(...inputs) {
  return twMerge(clsx(inputs));
}

// src/components/ui/button.tsx
var buttonVariants = cva(
  "inline-flex items-center justify-center whitespace-nowrap rounded-md text-sm font-medium ring-offset-white transition-colors focus-visible:outline-none focus-visible:ring-2 focus-visible:ring-neutral-950 focus-visible:ring-offset-2 disabled:pointer-events-none disabled:opacity-50 dark:ring-offset-neutral-950 dark:focus-visible:ring-neutral-300",
  {
    variants: {
      variant: {
        default: "bg-neutral-900 text-neutral-50 hover:bg-neutral-900/90 dark:bg-neutral-50 dark:text-neutral-900 dark:hover:bg-neutral-50/90",
        destructive: "bg-red-500 text-neutral-50 hover:bg-red-500/90 dark:bg-red-900 dark:text-neutral-50 dark:hover:bg-red-900/90",
        outline: "border border-neutral-200 bg-white hover:bg-neutral-100 hover:text-neutral-900 dark:border-neutral-800 dark:bg-neutral-950 dark:hover:bg-neutral-800 dark:hover:text-neutral-50",
        secondary: "bg-neutral-100 text-neutral-900 hover:bg-neutral-100/80 dark:bg-neutral-800 dark:text-neutral-50 dark:hover:bg-neutral-800/80",
        ghost: "hover:bg-neutral-100 hover:text-neutral-900 dark:hover:bg-neutral-800 dark:hover:text-neutral-50",
        link: "text-neutral-900 underline-offset-4 hover:underline dark:text-neutral-50"
      },
      size: {
        default: "h-10 px-4 py-2",
        sm: "h-9 rounded-md px-3",
        lg: "h-11 rounded-md px-8",
        icon: "h-10 w-10"
      }
    },
    defaultVariants: {
      variant: "default",
      size: "default"
    }
  }
);
var Button = React3.forwardRef(
  ({ className, variant, size, asChild = false, ...props }, ref) => {
    const Comp = asChild ? Slot : "button";
    return /* @__PURE__ */ React3.createElement(
      Comp,
      {
        className: cn(buttonVariants({ variant, size, className })),
        ref,
        ...props
      }
    );
  }
);
Button.displayName = "Button";

// src/components/Course.tsx
import {
  CheckIcon,
  PanelLeftClose,
  PanelLeftOpen,
  Smartphone
} from "lucide-react";

// src/components/MarkdownSection.tsx
import React4 from "react";
import Markdown3 from "react-markdown";
import rehypeRaw3 from "rehype-raw";
var MarkdownSection = (props) => {
  return /* @__PURE__ */ React4.createElement("div", { className: "h-full w-full flex flex-col justify-center items-center text-center" }, /* @__PURE__ */ React4.createElement(Markdown3, { className: "md:w-1/2", rehypePlugins: [rehypeRaw3] }, props.content));
};
var MarkdownSection_default = MarkdownSection;

// src/components/Course.tsx
var Course = ({
  id,
  lessons,
  canExit,
  menuHoverColor,
  menuSelectedColor
}) => {
  const [previewOpen, setPreviewOpen] = React5.useState(false);
  const [menuOpen, setMenuOpen] = React5.useState(false);
  const listItemRef = useRef(null);
  const divRef = React5.useRef(null);
  const [cookieArray, setCookieArray] = React5.useState(
    void 0
  );
  React5.useEffect(() => {
    const cookie = document.cookie.split(";").find((cookie2) => cookie2.includes(`current-position-for-${id}`));
    if (cookie) {
      const currentLessonId = cookie.split("=")[1];
      console.log(lessons.findIndex((l) => l.id == currentLessonId));
      setIndex(lessons.findIndex((l) => l.id == currentLessonId));
    }
    let cookieArray2 = document.cookie.split("; ").find((row) => row.startsWith(`progress-for-${id}`))?.split("=")[1].split(",");
    setCookieArray(cookieArray2);
  }, [lessons]);
  const [currentIndex, setIndex] = React5.useState(0);
  React5.useEffect(() => {
    if (menuOpen) {
      listItemRef.current.scrollIntoView({
        behavior: "smooth",
        block: "center"
      });
    }
  }, [menuOpen, listItemRef, currentIndex]);
  return /* @__PURE__ */ React5.createElement("div", { className: "flex h-full w-full relative" }, /* @__PURE__ */ React5.createElement(
    "div",
    {
      className: `w-[350px] border-r dark:border-r-neutral-700 overflow-y-auto transition-opacity ${menuOpen ? "opacity-100 block" : "opacity-0 hidden"}`
    },
    /* @__PURE__ */ React5.createElement("div", { className: "side-menu-content" }, /* @__PURE__ */ React5.createElement("div", { className: "py-4 pr-4 pl-2 sticky top-0 border-b dark:border-b-neutral-700 backdrop-blur" }, /* @__PURE__ */ React5.createElement("div", { className: "flex justify-between" }, /* @__PURE__ */ React5.createElement(
      "button",
      {
        onClick: () => setMenuOpen(false),
        className: buttonVariants({ variant: "ghost" })
      },
      /* @__PURE__ */ React5.createElement(PanelLeftClose, { size: 24 })
    ), canExit && /* @__PURE__ */ React5.createElement(
      "a",
      {
        href: "/courses",
        className: buttonVariants({ variant: "ghost" })
      },
      /* @__PURE__ */ React5.createElement("div", { className: "text-red-400" }, "Exit Course")
    ))), /* @__PURE__ */ React5.createElement("ul", { className: "py-4 px-4" }, lessons.map((section, index) => /* @__PURE__ */ React5.createElement("li", { key: index }, /* @__PURE__ */ React5.createElement(
      "button",
      {
        onClick: () => {
          setIndex(index);
          document.cookie = `current-position-for-${id}=${section.id}`;
        },
        ref: index === currentIndex ? listItemRef : void 0,
        className: `block w-full p-2 text-left ${menuHoverColor != null ? menuHoverColor : "hover:bg-neutral-100 dark:hover:bg-neutral-800"}  ${index === currentIndex ? `${menuSelectedColor != null ? menuSelectedColor : "bg-neutral-200 dark:bg-neutral-700"} rounded` : ""} ${cookieArray?.includes(section.id.toString()) ? "dark:text-green-300 text-green-600" : ""}`
      },
      (() => {
        switch (section.sectionType) {
          case "header":
            return /* @__PURE__ */ React5.createElement("span", null, "Introduction");
          default:
            return /* @__PURE__ */ React5.createElement("span", null, section.heading);
        }
      })()
    )))))
  ), /* @__PURE__ */ React5.createElement(
    "div",
    {
      className: "relative transition-opacity w-full overflow-y-auto",
      ref: divRef
    },
    /* @__PURE__ */ React5.createElement(
      BottomNavigation,
      {
        courseId: id,
        currentIndex,
        previewOpen,
        setIndex,
        contentLength: lessons.length,
        setPreviewOpen,
        content: lessons,
        menuOpen,
        setMenuOpen,
        cookieArray,
        setCookieArray
      }
    ),
    (() => {
      switch (lessons[currentIndex].sectionType) {
        case "slide":
          return /* @__PURE__ */ React5.createElement(
            SlideSection_default,
            {
              content: lessons[currentIndex],
              previewOpen,
              setPreviewOpen
            }
          );
        case "md":
          return /* @__PURE__ */ React5.createElement(
            MarkdownSection_default,
            {
              ...lessons[currentIndex]
            }
          );
        case "header":
          return /* @__PURE__ */ React5.createElement(
            HeaderSection_default,
            {
              ...lessons[currentIndex]
            }
          );
        default:
          return null;
      }
    })()
  ));
};
function BottomNavigation({
  courseId,
  currentIndex,
  previewOpen,
  contentLength,
  setIndex,
  setPreviewOpen,
  content,
  menuOpen,
  setMenuOpen,
  cookieArray,
  setCookieArray
}) {
  const completeRef = React5.useRef(null);
  const hasPreview = content[currentIndex] !== void 0 && "previewImage" in content[currentIndex];
  React5.useEffect(() => {
    document.addEventListener("keydown", function(event) {
      const keyPressed = event.key.toLowerCase();
      if (keyPressed === "c" && !event.ctrlKey && !event.altKey && !event.shiftKey && !event.metaKey) {
        completeKeymap();
      }
    });
  }, []);
  function completeKeymap() {
    const item = completeRef.current;
    if (!item)
      return;
    item.classList.add("scale-75");
    setTimeout(() => {
      item.classList.remove("scale-75");
    }, 100);
    completeRef.current?.click();
    completeRef.current?.focus();
  }
  function onClickComplete() {
    if (!cookieArray) {
      cookieArray = [];
    }
    if (!cookieArray.includes(content[currentIndex].id.toString())) {
      cookieArray.push(content[currentIndex].id.toString());
      setCookieArray(cookieArray);
    }
    document.cookie = `progress-for-${courseId}=${cookieArray}`;
    if (currentIndex === contentLength - 1) {
      return;
    }
    if (content[currentIndex + 1].sectionType !== "slide" || content[currentIndex + 1].previewImage === void 0) {
      setPreviewOpen(false);
    }
    setIndex(currentIndex + 1);
    console.log(content[currentIndex]);
    document.cookie = `current-position-for-${courseId}=${content[currentIndex + 1].id}`;
  }
  return /* @__PURE__ */ React5.createElement(
    "div",
    {
      className: `fixed z-50 bottom-2 left-2 p-4 ${menuOpen ? `pl-72` : ``}`
    },
    /* @__PURE__ */ React5.createElement(
      "div",
      {
        className: `flex h-full items-center justify-center space-x-4 rounded`
      },
      !menuOpen && /* @__PURE__ */ React5.createElement(
        "button",
        {
          "data-tooltip-target": "tooltip-menu",
          type: "button",
          className: buttonVariants({ variant: "default" }),
          onClick: () => setMenuOpen(!menuOpen)
        },
        /* @__PURE__ */ React5.createElement("div", { className: "w-full h-full flex items-center justify-center active:scale-75 transition-transform" }, /* @__PURE__ */ React5.createElement(PanelLeftOpen, { size: 28 })),
        /* @__PURE__ */ React5.createElement("span", { className: "sr-only" }, "Menu")
      ),
      /* @__PURE__ */ React5.createElement(
        "button",
        {
          "data-tooltip-target": "tooltip-complete",
          type: "button",
          className: buttonVariants({ variant: "default" }),
          onClick: onClickComplete
        },
        /* @__PURE__ */ React5.createElement(
          "div",
          {
            ref: completeRef,
            className: "w-full h-full flex items-center justify-center active:scale-75 transition-transform"
          },
          /* @__PURE__ */ React5.createElement(CheckIcon, { size: 28 })
        ),
        /* @__PURE__ */ React5.createElement("span", { className: "sr-only" }, "Complete")
      ),
      /* @__PURE__ */ React5.createElement(
        "div",
        {
          id: "tooltip-complete",
          role: "tooltip",
          className: "absolute z-10 invisible inline-block px-3 py-2 text-sm font-medium text-white transition-opacity duration-300 bg-neutral-900 rounded-lg shadow-sm opacity-0 tooltip dark:bg-neutral-700"
        },
        "Complete",
        /* @__PURE__ */ React5.createElement("div", { className: "tooltip-arrow", "data-popper-arrow": true })
      ),
      hasPreview && /* @__PURE__ */ React5.createElement(React5.Fragment, null, /* @__PURE__ */ React5.createElement(
        "button",
        {
          onClick: () => setPreviewOpen(!previewOpen),
          "data-tooltip-target": "tooltip-preview",
          type: "button",
          className: buttonVariants({ variant: "default" })
        },
        /* @__PURE__ */ React5.createElement("div", { className: "w-full h-full flex items-center justify-center active:scale-75 transition-transform" }, /* @__PURE__ */ React5.createElement(Smartphone, { size: 28 })),
        /* @__PURE__ */ React5.createElement("span", { className: "sr-only" }, "Preview")
      ), /* @__PURE__ */ React5.createElement(
        "div",
        {
          id: "tooltip-preview",
          role: "tooltip",
          className: "absolute z-10 invisible inline-block px-3 py-2 text-sm font-medium text-white transition-opacity duration-300 bg-neutral-900 rounded-lg shadow-sm opacity-0 tooltip dark:bg-neutral-700"
        },
        "Preview",
        /* @__PURE__ */ React5.createElement("div", { className: "tooltip-arrow", "data-popper-arrow": true })
      ))
    )
  );
}
export {
  Course
};
